﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinGrid;

namespace GridValidatorTest
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			var valSettings = ultraValidator1.GetValidationSettings(ultraTextEditor1);
			valSettings.Condition = new LengthCondition(15);
			valSettings.ValidationTrigger = ValidationTrigger.Programmatic;
			valSettings.ValidationPropertyName = "Text";
			valSettings.NotificationSettings.Action = NotificationAction.Image;
			valSettings.NotificationSettings.Text = "The current text is too long.";
			ultraValidator1.SetValidationSettings(ultraTextEditor1, valSettings);
		}

		private void ultraGrid1_CellChange(object sender, CellEventArgs e)
		{
			ultraValidator1.Validate();
			ultraGrid1.Refresh();
		}
	}

	class LengthCondition : ICondition
	{
		private int maxLength;

		public LengthCondition(int maxLength)
		{
			this.maxLength = maxLength;
		}

		#region ICondition Members

		public bool Matches(object value, IConditionContextProvider contextProvider)
		{
			return (value.ToString().Length <= maxLength);
		}

		public event EventHandler PropertyChanged;

		#endregion

		#region ICloneable Members

		public object Clone()
		{
			return new LengthCondition(this.maxLength);
		}

		#endregion
	}
}
